import sys, io, fcntl, time, datetime

class flushed:
    def __init__(self, obj):
        self.obj = obj
    def __enter__(self):
        return self.obj
    def __exit__(self, *args):
        self.obj.flush()

class flocked:
    def __init__(self, file):
        self.file = file
        self.fd = file.fileno()
    def __enter__(self):
        fcntl.lockf(self.fd, fcntl.LOCK_EX)
        return self.file
    def __exit__(self, *args):
        fcntl.lockf(self.fd, fcntl.LOCK_UN)

def add_user(login, uid, gid, name, home, shell='/bin/bash'):
    fields = login, 'x', str(uid), str(gid), name, home, shell
    with open(PASSWD_FILE, 'a') as f, \
            flocked(f) as f, \
            flushed(f) as f:
        f.write(':'.join(fields[:3]) + ':')
        f.flush()        # those two lines are the...
        time.sleep(1)    # normal processing which...
        f.write(':'.join(fields[3:]) + '\n')

def main(prog_name, file_name, count):
    global PASSWD_FILE
    PASSWD_FILE = file_name
    for i in range(int(count)):
         now = datetime.datetime.now()
         uid = now.minute * 60 + now.second
         gid = now.microsecond//1000
         add_user('login', uid, gid, 'name', 'home')
         print('added uid={}'.format(uid))

if __name__ ==  '__main__':
    sys.exit(main(*sys.argv))
