/* ####################################################################### */
/* This script compares the speed of the computation of a polynomial       */
/* in C in a couple of different ways.                                     */
/*                                                                         */
/* Author: Francesc Alted                                                  */
/* Date: 2010-10-01                                                        */
/* ####################################################################### */


#include <stdio.h>
#include <math.h>
#include <unistd.h>
#include <sys/time.h>
#include <time.h>


#define N  10*1000*1000

double x[N];
double y[N];

/* Given two timeval stamps, return the difference in seconds */
float getseconds(struct timeval last, struct timeval current) {
  int sec, usec;

  sec = current.tv_sec - last.tv_sec;
  usec = current.tv_usec - last.tv_usec;
  return (float)(((double)sec + usec*1e-6));
}

int main(void) {
  int i;
  double inf = -1;
  double dN = N;
  struct timeval last, current;
  float tspend;

  /* Initialize arrays */
  for(i=0; i<N; i++) {
    x[i] = inf+((2.*i)/dN);
  }

  /* Perform actual computation */
  gettimeofday(&last, NULL);
  for(i=0; i<N; i++) {
    /* y[i] = .25*pow(x[i],3.) + .75*pow(x[i],2.) - 1.5*x[i] - 2; */
    y[i] = ((.25*x[i] + .75)*x[i] - 1.5)*x[i] - 2;
    /* y[i] = pow(sin(x[i]), 2) + pow(cos(x[i]), 2); */
  }
  gettimeofday(&current, NULL);
  tspend = getseconds(last, current);
  printf("Compute time:\t %f s\n", tspend);

  return(0);
}
